import 'package:analyzer/dart/element/element.dart';
import 'package:like_sealed_gen/src/content/sealed_collection_content.dart';
import 'package:like_sealed_gen/src/content/sealed_switch_content.dart';
import 'package:like_sealed_gen/src/content/sealed_switch_impl_content.dart';
import 'package:like_sealed_gen/src/util.dart';

class ContentFormat {
  final imports = <String>[];
  final bool isShortName;
  final bool isCollection;
  final bool isSwitchInterface;
  final bool isSwitchImpl;

  ContentFormat(
    this.isShortName,
    this.isCollection,
    this.isSwitchInterface,
    this.isSwitchImpl,
  );

  String build(
      List<String> imports, String className, List<ClassElement> types) {
    var content = "";
//    content += _imports(imports);
//    content += "import 'package:meta/meta.dart';\n";
    if (isCollection) {
      content +=
          SealedCollectionContent(isShortName, className, types).content();
    }
    if (isSwitchInterface) {
      content += SealedSwitchContent(isShortName, className, types).content();
    }
    if (isSwitchImpl) {
      content +=
          SealedSwitchImplContent(isShortName, className, types).content();
    }
    return content;
  }

  String _imports(List<String> imports) {
    var out = "";
    for (var import in imports) {
      out += "import '$import';\n";
    }
    return out;
  }
}
