import 'package:analyzer/dart/element/element.dart';
import 'package:like_sealed_gen/src/util.dart';

class SealedSwitchContent {
  final String className;
  final List<ClassElement> types;
  final bool isShortName;

  SealedSwitchContent(this.isShortName, this.className, this.types);

  String content() {
    String typeChecker = "";
    String caseFunction = "";
    for (var type in types) {
      final typeName = type.name;
      if (typeName == className) {
        typeChecker += "onDefault(type)";
        caseFunction +=
            "T onDefault($typeName ${typeName.firstToLower}) => null;";
      } else {
        String functionName = typeName;
        if (isShortName) {
          functionName = functionName.removeIf(className);
        }
        typeChecker += "type is $typeName? on$functionName(type): ";
        caseFunction += "T on$functionName($typeName ${functionName.firstToLower});";
      }
    }

    return """
    abstract class ${className}Switch<T> implements SealedSwitch<$className,T> {
      T switchCase($className type)=>$typeChecker;
      $caseFunction
    }
    """;
  }
}
